org.apache.hc.client5.http.impl.cookie

## Class RFC6265CookieSpec

- java.lang.Object
- - org.apache.hc.client5.http.impl.cookie.RFC6265CookieSpec

All Implemented Interfaces:
  CookieSpec

Direct Known Subclasses:
  RFC6265LaxSpec, RFC6265StrictSpec

    @Contract(threading=SAFE)
    public class RFC6265CookieSpec
    extends Object
    implements CookieSpec

Cookie management functions shared by RFC 6265 compliant specification.

Since:
  4.5

### Constructor Summary

Constructors
`protected` `RFC6265CookieSpec(CommonCookieAttributeHandler... handlers)`

### Method Summary

All Methods Instance Methods Concrete Methods
`List<org.apache.hc.core5.http.Header>` `formatCookies(List<Cookie> cookies)` Create `"Cookie"` headers for an array of Cookies.
`boolean` `match(Cookie cookie, CookieOrigin origin)` Determines if a Cookie matches the target location.
`List<Cookie>` `parse(org.apache.hc.core5.http.Header header, CookieOrigin origin)` Parse the `"Set-Cookie"` Header into an array of Cookies.
`void` `validate(Cookie cookie, CookieOrigin origin)` Validate the cookie according to validation rules defined by the cookie specification.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### RFC6265CookieSpec

    protected RFC6265CookieSpec(CommonCookieAttributeHandler... handlers)

### Method Detail

#### parse

    public final List<Cookie> parse(org.apache.hc.core5.http.Header header,
                                    CookieOrigin origin)
                             throws MalformedCookieException

Description copied from interface: `CookieSpec`
Parse the `"Set-Cookie"` Header into an array of Cookies.

This method will not perform the validation of the resultant `Cookie`s

Specified by:
  `parse` in interface `CookieSpec`
Parameters:
  `header` - the `Set-Cookie` received from the server
  `origin` - details of the cookie origin
Returns:
  an array of `Cookie`s parsed from the header
Throws:
  `MalformedCookieException` - if an exception occurs during parsing
See Also:
  `CookieSpec.validate(org.apache.hc.client5.http.cookie.Cookie, org.apache.hc.client5.http.cookie.CookieOrigin)`

#### validate

    public final void validate(Cookie cookie,
                               CookieOrigin origin)
                        throws MalformedCookieException

Description copied from interface: `CookieSpec`
Validate the cookie according to validation rules defined by the cookie specification.

Specified by:
  `validate` in interface `CookieSpec`
Parameters:
  `cookie` - the Cookie to validate
  `origin` - details of the cookie origin
Throws:
  `MalformedCookieException` - if the cookie is invalid

#### match

    public final boolean match(Cookie cookie,
                               CookieOrigin origin)

Description copied from interface: `CookieSpec`
Determines if a Cookie matches the target location.

Specified by:
  `match` in interface `CookieSpec`
Parameters:
  `cookie` - the Cookie to be matched
  `origin` - the target to test against
Returns:
  `true` if the cookie should be submitted with a request with given attributes, `false` otherwise.

#### formatCookies

    public List<org.apache.hc.core5.http.Header> formatCookies(List<Cookie> cookies)

Description copied from interface: `CookieSpec`
Create `"Cookie"` headers for an array of Cookies.

Specified by:
  `formatCookies` in interface `CookieSpec`
Parameters:
  `cookies` - the Cookies format into a Cookie header
Returns:
  a Header for the given Cookies.